# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from smarthome_heater_msgs/HeatingStateData.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import sensor_msgs.msg
import smarthome_heater_msgs.msg
import std_msgs.msg

class HeatingStateData(genpy.Message):
  _md5sum = "c6acddf0526c6ab3dbd55a402928ed19"
  _type = "smarthome_heater_msgs/HeatingStateData"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """## State data heating message
## Common state of heating

Header header

# PID
float64 proportional
float64 integral
float64 derivative

# Goal
sensor_msgs/Temperature temperatureReal
sensor_msgs/Temperature temperatureGoal
HeatingTemperatureSlot timeSlotCurrent

# States
bool heaterState
bool sensorState

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/Temperature
 # Single temperature reading.

 Header header           # timestamp is the time the temperature was measured
                         # frame_id is the location of the temperature reading

 float64 temperature     # Measurement of the Temperature in Degrees Celsius

 float64 variance        # 0 is interpreted as variance unknown
================================================================================
MSG: smarthome_heater_msgs/HeatingTemperatureSlot
## State data heating message
## Common state of heating

Header header

string dateBegin # format: yy-MM-dd'T'HH:mm:ss
string dateEnd # format: yy-MM-dd'T'HH:mm:ss
sensor_msgs/Temperature temperature
uint32 priority # a higher value has the priority
float32 frequency # 0 = no frequency, use specific dateBegin, dateEnd
string frequencyUnit"""
  __slots__ = ['header','proportional','integral','derivative','temperatureReal','temperatureGoal','timeSlotCurrent','heaterState','sensorState']
  _slot_types = ['std_msgs/Header','float64','float64','float64','sensor_msgs/Temperature','sensor_msgs/Temperature','smarthome_heater_msgs/HeatingTemperatureSlot','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,proportional,integral,derivative,temperatureReal,temperatureGoal,timeSlotCurrent,heaterState,sensorState

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(HeatingStateData, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.proportional is None:
        self.proportional = 0.
      if self.integral is None:
        self.integral = 0.
      if self.derivative is None:
        self.derivative = 0.
      if self.temperatureReal is None:
        self.temperatureReal = sensor_msgs.msg.Temperature()
      if self.temperatureGoal is None:
        self.temperatureGoal = sensor_msgs.msg.Temperature()
      if self.timeSlotCurrent is None:
        self.timeSlotCurrent = smarthome_heater_msgs.msg.HeatingTemperatureSlot()
      if self.heaterState is None:
        self.heaterState = False
      if self.sensorState is None:
        self.sensorState = False
    else:
      self.header = std_msgs.msg.Header()
      self.proportional = 0.
      self.integral = 0.
      self.derivative = 0.
      self.temperatureReal = sensor_msgs.msg.Temperature()
      self.temperatureGoal = sensor_msgs.msg.Temperature()
      self.timeSlotCurrent = smarthome_heater_msgs.msg.HeatingTemperatureSlot()
      self.heaterState = False
      self.sensorState = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d3I.pack(_x.proportional, _x.integral, _x.derivative, _x.temperatureReal.header.seq, _x.temperatureReal.header.stamp.secs, _x.temperatureReal.header.stamp.nsecs))
      _x = self.temperatureReal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3I.pack(_x.temperatureReal.temperature, _x.temperatureReal.variance, _x.temperatureGoal.header.seq, _x.temperatureGoal.header.stamp.secs, _x.temperatureGoal.header.stamp.nsecs))
      _x = self.temperatureGoal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3I.pack(_x.temperatureGoal.temperature, _x.temperatureGoal.variance, _x.timeSlotCurrent.header.seq, _x.timeSlotCurrent.header.stamp.secs, _x.timeSlotCurrent.header.stamp.nsecs))
      _x = self.timeSlotCurrent.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.timeSlotCurrent.dateBegin
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.timeSlotCurrent.dateEnd
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.timeSlotCurrent.temperature.header.seq, _x.timeSlotCurrent.temperature.header.stamp.secs, _x.timeSlotCurrent.temperature.header.stamp.nsecs))
      _x = self.timeSlotCurrent.temperature.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2dIf.pack(_x.timeSlotCurrent.temperature.temperature, _x.timeSlotCurrent.temperature.variance, _x.timeSlotCurrent.priority, _x.timeSlotCurrent.frequency))
      _x = self.timeSlotCurrent.frequencyUnit
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2B.pack(_x.heaterState, _x.sensorState))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.temperatureReal is None:
        self.temperatureReal = sensor_msgs.msg.Temperature()
      if self.temperatureGoal is None:
        self.temperatureGoal = sensor_msgs.msg.Temperature()
      if self.timeSlotCurrent is None:
        self.timeSlotCurrent = smarthome_heater_msgs.msg.HeatingTemperatureSlot()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.proportional, _x.integral, _x.derivative, _x.temperatureReal.header.seq, _x.temperatureReal.header.stamp.secs, _x.temperatureReal.header.stamp.nsecs,) = _struct_3d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.temperatureReal.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.temperatureReal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.temperatureReal.temperature, _x.temperatureReal.variance, _x.temperatureGoal.header.seq, _x.temperatureGoal.header.stamp.secs, _x.temperatureGoal.header.stamp.nsecs,) = _struct_2d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.temperatureGoal.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.temperatureGoal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.temperatureGoal.temperature, _x.temperatureGoal.variance, _x.timeSlotCurrent.header.seq, _x.timeSlotCurrent.header.stamp.secs, _x.timeSlotCurrent.header.stamp.nsecs,) = _struct_2d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.timeSlotCurrent.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.timeSlotCurrent.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.timeSlotCurrent.dateBegin = str[start:end].decode('utf-8')
      else:
        self.timeSlotCurrent.dateBegin = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.timeSlotCurrent.dateEnd = str[start:end].decode('utf-8')
      else:
        self.timeSlotCurrent.dateEnd = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.timeSlotCurrent.temperature.header.seq, _x.timeSlotCurrent.temperature.header.stamp.secs, _x.timeSlotCurrent.temperature.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.timeSlotCurrent.temperature.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.timeSlotCurrent.temperature.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.timeSlotCurrent.temperature.temperature, _x.timeSlotCurrent.temperature.variance, _x.timeSlotCurrent.priority, _x.timeSlotCurrent.frequency,) = _struct_2dIf.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.timeSlotCurrent.frequencyUnit = str[start:end].decode('utf-8')
      else:
        self.timeSlotCurrent.frequencyUnit = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.heaterState, _x.sensorState,) = _struct_2B.unpack(str[start:end])
      self.heaterState = bool(self.heaterState)
      self.sensorState = bool(self.sensorState)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3d3I.pack(_x.proportional, _x.integral, _x.derivative, _x.temperatureReal.header.seq, _x.temperatureReal.header.stamp.secs, _x.temperatureReal.header.stamp.nsecs))
      _x = self.temperatureReal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3I.pack(_x.temperatureReal.temperature, _x.temperatureReal.variance, _x.temperatureGoal.header.seq, _x.temperatureGoal.header.stamp.secs, _x.temperatureGoal.header.stamp.nsecs))
      _x = self.temperatureGoal.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3I.pack(_x.temperatureGoal.temperature, _x.temperatureGoal.variance, _x.timeSlotCurrent.header.seq, _x.timeSlotCurrent.header.stamp.secs, _x.timeSlotCurrent.header.stamp.nsecs))
      _x = self.timeSlotCurrent.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.timeSlotCurrent.dateBegin
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.timeSlotCurrent.dateEnd
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.timeSlotCurrent.temperature.header.seq, _x.timeSlotCurrent.temperature.header.stamp.secs, _x.timeSlotCurrent.temperature.header.stamp.nsecs))
      _x = self.timeSlotCurrent.temperature.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2dIf.pack(_x.timeSlotCurrent.temperature.temperature, _x.timeSlotCurrent.temperature.variance, _x.timeSlotCurrent.priority, _x.timeSlotCurrent.frequency))
      _x = self.timeSlotCurrent.frequencyUnit
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2B.pack(_x.heaterState, _x.sensorState))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.temperatureReal is None:
        self.temperatureReal = sensor_msgs.msg.Temperature()
      if self.temperatureGoal is None:
        self.temperatureGoal = sensor_msgs.msg.Temperature()
      if self.timeSlotCurrent is None:
        self.timeSlotCurrent = smarthome_heater_msgs.msg.HeatingTemperatureSlot()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 36
      (_x.proportional, _x.integral, _x.derivative, _x.temperatureReal.header.seq, _x.temperatureReal.header.stamp.secs, _x.temperatureReal.header.stamp.nsecs,) = _struct_3d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.temperatureReal.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.temperatureReal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.temperatureReal.temperature, _x.temperatureReal.variance, _x.temperatureGoal.header.seq, _x.temperatureGoal.header.stamp.secs, _x.temperatureGoal.header.stamp.nsecs,) = _struct_2d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.temperatureGoal.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.temperatureGoal.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.temperatureGoal.temperature, _x.temperatureGoal.variance, _x.timeSlotCurrent.header.seq, _x.timeSlotCurrent.header.stamp.secs, _x.timeSlotCurrent.header.stamp.nsecs,) = _struct_2d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.timeSlotCurrent.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.timeSlotCurrent.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.timeSlotCurrent.dateBegin = str[start:end].decode('utf-8')
      else:
        self.timeSlotCurrent.dateBegin = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.timeSlotCurrent.dateEnd = str[start:end].decode('utf-8')
      else:
        self.timeSlotCurrent.dateEnd = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.timeSlotCurrent.temperature.header.seq, _x.timeSlotCurrent.temperature.header.stamp.secs, _x.timeSlotCurrent.temperature.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.timeSlotCurrent.temperature.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.timeSlotCurrent.temperature.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.timeSlotCurrent.temperature.temperature, _x.timeSlotCurrent.temperature.variance, _x.timeSlotCurrent.priority, _x.timeSlotCurrent.frequency,) = _struct_2dIf.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.timeSlotCurrent.frequencyUnit = str[start:end].decode('utf-8')
      else:
        self.timeSlotCurrent.frequencyUnit = str[start:end]
      _x = self
      start = end
      end += 2
      (_x.heaterState, _x.sensorState,) = _struct_2B.unpack(str[start:end])
      self.heaterState = bool(self.heaterState)
      self.sensorState = bool(self.sensorState)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3d3I = struct.Struct("<3d3I")
_struct_3I = struct.Struct("<3I")
_struct_2d3I = struct.Struct("<2d3I")
_struct_2B = struct.Struct("<2B")
_struct_2dIf = struct.Struct("<2dIf")
