# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from smarthome_heater_msgs/SensorTemperatureStateData.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import sensor_msgs.msg
import std_msgs.msg

class SensorTemperatureStateData(genpy.Message):
  _md5sum = "7a6f572218d52125fe77222be46f6b52"
  _type = "smarthome_heater_msgs/SensorTemperatureStateData"
  _has_header = True #flag to mark the presence of a Header object
  _full_text = """## State data temperature sensor message
## Common state of temperature sensor

Header header

# Temperatures
sensor_msgs/Temperature temperatureAmbiant
sensor_msgs/Temperature temperatureObject

# State    0: Unknown, 1: Init, 2: Enable, 3: Shutdown
uint32 state

# State constants
uint32 UNKNOWN=0
uint32 INIT=1
uint32 ENABLE=2
uint32 SHUTDOWN=3

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/Temperature
 # Single temperature reading.

 Header header           # timestamp is the time the temperature was measured
                         # frame_id is the location of the temperature reading

 float64 temperature     # Measurement of the Temperature in Degrees Celsius

 float64 variance        # 0 is interpreted as variance unknown"""
  # Pseudo-constants
  UNKNOWN = 0
  INIT = 1
  ENABLE = 2
  SHUTDOWN = 3

  __slots__ = ['header','temperatureAmbiant','temperatureObject','state']
  _slot_types = ['std_msgs/Header','sensor_msgs/Temperature','sensor_msgs/Temperature','uint32']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,temperatureAmbiant,temperatureObject,state

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(SensorTemperatureStateData, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.temperatureAmbiant is None:
        self.temperatureAmbiant = sensor_msgs.msg.Temperature()
      if self.temperatureObject is None:
        self.temperatureObject = sensor_msgs.msg.Temperature()
      if self.state is None:
        self.state = 0
    else:
      self.header = std_msgs.msg.Header()
      self.temperatureAmbiant = sensor_msgs.msg.Temperature()
      self.temperatureObject = sensor_msgs.msg.Temperature()
      self.state = 0

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.temperatureAmbiant.header.seq, _x.temperatureAmbiant.header.stamp.secs, _x.temperatureAmbiant.header.stamp.nsecs))
      _x = self.temperatureAmbiant.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3I.pack(_x.temperatureAmbiant.temperature, _x.temperatureAmbiant.variance, _x.temperatureObject.header.seq, _x.temperatureObject.header.stamp.secs, _x.temperatureObject.header.stamp.nsecs))
      _x = self.temperatureObject.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2dI.pack(_x.temperatureObject.temperature, _x.temperatureObject.variance, _x.state))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.temperatureAmbiant is None:
        self.temperatureAmbiant = sensor_msgs.msg.Temperature()
      if self.temperatureObject is None:
        self.temperatureObject = sensor_msgs.msg.Temperature()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.temperatureAmbiant.header.seq, _x.temperatureAmbiant.header.stamp.secs, _x.temperatureAmbiant.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.temperatureAmbiant.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.temperatureAmbiant.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.temperatureAmbiant.temperature, _x.temperatureAmbiant.variance, _x.temperatureObject.header.seq, _x.temperatureObject.header.stamp.secs, _x.temperatureObject.header.stamp.nsecs,) = _struct_2d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.temperatureObject.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.temperatureObject.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 20
      (_x.temperatureObject.temperature, _x.temperatureObject.variance, _x.state,) = _struct_2dI.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.temperatureAmbiant.header.seq, _x.temperatureAmbiant.header.stamp.secs, _x.temperatureAmbiant.header.stamp.nsecs))
      _x = self.temperatureAmbiant.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2d3I.pack(_x.temperatureAmbiant.temperature, _x.temperatureAmbiant.variance, _x.temperatureObject.header.seq, _x.temperatureObject.header.stamp.secs, _x.temperatureObject.header.stamp.nsecs))
      _x = self.temperatureObject.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2dI.pack(_x.temperatureObject.temperature, _x.temperatureObject.variance, _x.state))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.temperatureAmbiant is None:
        self.temperatureAmbiant = sensor_msgs.msg.Temperature()
      if self.temperatureObject is None:
        self.temperatureObject = sensor_msgs.msg.Temperature()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.temperatureAmbiant.header.seq, _x.temperatureAmbiant.header.stamp.secs, _x.temperatureAmbiant.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.temperatureAmbiant.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.temperatureAmbiant.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 28
      (_x.temperatureAmbiant.temperature, _x.temperatureAmbiant.variance, _x.temperatureObject.header.seq, _x.temperatureObject.header.stamp.secs, _x.temperatureObject.header.stamp.nsecs,) = _struct_2d3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.temperatureObject.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.temperatureObject.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 20
      (_x.temperatureObject.temperature, _x.temperatureObject.variance, _x.state,) = _struct_2dI.unpack(str[start:end])
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I = struct.Struct("<3I")
_struct_2dI = struct.Struct("<2dI")
_struct_2d3I = struct.Struct("<2d3I")
