# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from smarthome_heater_msgs/HeatingAddTimeSlotRequest.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import sensor_msgs.msg
import smarthome_heater_msgs.msg
import std_msgs.msg

class HeatingAddTimeSlotRequest(genpy.Message):
  _md5sum = "e9aaec681f4ab93ad032e6123fb68191"
  _type = "smarthome_heater_msgs/HeatingAddTimeSlotRequest"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """HeatingTemperatureSlot slot

================================================================================
MSG: smarthome_heater_msgs/HeatingTemperatureSlot
## State data heating message
## Common state of heating

Header header

string dateBegin # format: yy-MM-dd'T'HH:mm:ss
string dateEnd # format: yy-MM-dd'T'HH:mm:ss
sensor_msgs/Temperature temperature
uint32 priority # a higher value has the priority
float32 frequency # 0 = no frequency, use specific dateBegin, dateEnd
string frequencyUnit
================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id

================================================================================
MSG: sensor_msgs/Temperature
 # Single temperature reading.

 Header header           # timestamp is the time the temperature was measured
                         # frame_id is the location of the temperature reading

 float64 temperature     # Measurement of the Temperature in Degrees Celsius

 float64 variance        # 0 is interpreted as variance unknown"""
  __slots__ = ['slot']
  _slot_types = ['smarthome_heater_msgs/HeatingTemperatureSlot']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       slot

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(HeatingAddTimeSlotRequest, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.slot is None:
        self.slot = smarthome_heater_msgs.msg.HeatingTemperatureSlot()
    else:
      self.slot = smarthome_heater_msgs.msg.HeatingTemperatureSlot()

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.slot.header.seq, _x.slot.header.stamp.secs, _x.slot.header.stamp.nsecs))
      _x = self.slot.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.slot.dateBegin
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.slot.dateEnd
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.slot.temperature.header.seq, _x.slot.temperature.header.stamp.secs, _x.slot.temperature.header.stamp.nsecs))
      _x = self.slot.temperature.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2dIf.pack(_x.slot.temperature.temperature, _x.slot.temperature.variance, _x.slot.priority, _x.slot.frequency))
      _x = self.slot.frequencyUnit
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      if self.slot is None:
        self.slot = smarthome_heater_msgs.msg.HeatingTemperatureSlot()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.slot.header.seq, _x.slot.header.stamp.secs, _x.slot.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.slot.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.slot.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.slot.dateBegin = str[start:end].decode('utf-8')
      else:
        self.slot.dateBegin = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.slot.dateEnd = str[start:end].decode('utf-8')
      else:
        self.slot.dateEnd = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.slot.temperature.header.seq, _x.slot.temperature.header.stamp.secs, _x.slot.temperature.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.slot.temperature.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.slot.temperature.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.slot.temperature.temperature, _x.slot.temperature.variance, _x.slot.priority, _x.slot.frequency,) = _struct_2dIf.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.slot.frequencyUnit = str[start:end].decode('utf-8')
      else:
        self.slot.frequencyUnit = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_struct_3I.pack(_x.slot.header.seq, _x.slot.header.stamp.secs, _x.slot.header.stamp.nsecs))
      _x = self.slot.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.slot.dateBegin
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self.slot.dateEnd
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_3I.pack(_x.slot.temperature.header.seq, _x.slot.temperature.header.stamp.secs, _x.slot.temperature.header.stamp.nsecs))
      _x = self.slot.temperature.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
      _x = self
      buff.write(_struct_2dIf.pack(_x.slot.temperature.temperature, _x.slot.temperature.variance, _x.slot.priority, _x.slot.frequency))
      _x = self.slot.frequencyUnit
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      if python3:
        buff.write(struct.pack('<I%sB'%length, length, *_x))
      else:
        buff.write(struct.pack('<I%ss'%length, length, _x))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      if self.slot is None:
        self.slot = smarthome_heater_msgs.msg.HeatingTemperatureSlot()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.slot.header.seq, _x.slot.header.stamp.secs, _x.slot.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.slot.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.slot.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.slot.dateBegin = str[start:end].decode('utf-8')
      else:
        self.slot.dateBegin = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.slot.dateEnd = str[start:end].decode('utf-8')
      else:
        self.slot.dateEnd = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.slot.temperature.header.seq, _x.slot.temperature.header.stamp.secs, _x.slot.temperature.header.stamp.nsecs,) = _struct_3I.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.slot.temperature.header.frame_id = str[start:end].decode('utf-8')
      else:
        self.slot.temperature.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 24
      (_x.slot.temperature.temperature, _x.slot.temperature.variance, _x.slot.priority, _x.slot.frequency,) = _struct_2dIf.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.slot.frequencyUnit = str[start:end].decode('utf-8')
      else:
        self.slot.frequencyUnit = str[start:end]
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_3I = struct.Struct("<3I")
_struct_2dIf = struct.Struct("<2dIf")
# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from smarthome_heater_msgs/HeatingAddTimeSlotResponse.msg. Do not edit."""
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class HeatingAddTimeSlotResponse(genpy.Message):
  _md5sum = "eb13ac1f1354ccecb7941ee8fa2192e8"
  _type = "smarthome_heater_msgs/HeatingAddTimeSlotResponse"
  _has_header = False #flag to mark the presence of a Header object
  _full_text = """bool result

"""
  __slots__ = ['result']
  _slot_types = ['bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       result

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(HeatingAddTimeSlotResponse, self).__init__(*args, **kwds)
      #message fields cannot be None, assign default values for those that are
      if self.result is None:
        self.result = False
    else:
      self.result = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      buff.write(_struct_B.pack(self.result))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    try:
      end = 0
      start = end
      end += 1
      (self.result,) = _struct_B.unpack(str[start:end])
      self.result = bool(self.result)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      buff.write(_struct_B.pack(self.result))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    try:
      end = 0
      start = end
      end += 1
      (self.result,) = _struct_B.unpack(str[start:end])
      self.result = bool(self.result)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e) #most likely buffer underfill

_struct_I = genpy.struct_I
_struct_B = struct.Struct("<B")
class HeatingAddTimeSlot(object):
  _type          = 'smarthome_heater_msgs/HeatingAddTimeSlot'
  _md5sum = '8f90c66a339968582b8bd7309889d469'
  _request_class  = HeatingAddTimeSlotRequest
  _response_class = HeatingAddTimeSlotResponse
